\section{Static Malware Detection with YARA}
For this first question, we have to create some YARA rules to detect malicious files through some groups of files.

%==================================================================%
\subsection{File reading/writing}
\begin{center}
    \textit{The YARA rules for this exercise is named: \textbf{"file\_rules.yar"}}
\end{center}

\subsubsection{Description}
The YARA file is separated into two parts: one for the \textbf{reading part}, the other for the \textbf{writing part}.\\

For the reading part, our rules check for specific strings and regular expressions. It verifies an SSH private key file (\textit{key\_rsa}), a file path leading to an SSH private key, and commands or functions that read or scan data from a file or terminal input (\textit{read}, \textit{scan}, \textit{gets}, \textit{getc}).\\

For the writing part, the rules analyse if the program has strings or regular expressions for the crontab file and commands or functions that can write into this file.

\subsubsection{Results}
On the test suite provided \textbf{for the reading problem}, our YARA rules detect the following:
\begin{itemize}
    \item \textbf{\textcolor{green}{8 out of 8 malicious files}}: [\textit{mal1}, \textit{mal2}, \textit{mal3}, \textit{mal4}, \textit{mal7}, \textit{mal8}, \textit{mal10}, \textit{mal11}]
    \item \textbf{\textcolor{green}{0 out of 2 clean files}}.\\
\end{itemize}
 
On the test suite provided \textbf{for the writing problem}, our YARA rules detect:
\begin{itemize}
    \item \textbf{\textcolor{green}{4 out of 4 malicious files}}: [\textit{mal1}, \textit{mal3}, \textit{mal4}, \textit{mal5}]
    \item \textbf{\textcolor{red}{2 out of 3 clean files}}: [\textit{clean1}, \textit{clean2}].
\end{itemize}

%==================================================================%
\subsection{Connection to remote website}
\begin{center}
    \textit{The YARA rules for this exercise is named: \textbf{"connect\_rules.yar"}}
\end{center}

\subsubsection{Description}
We mainly check as a regular expression the following strings: (\textit{socket}, \textit{bind}, \textit{connect}, \textit{curl}, \textit{GET}, \textit{memset}).\\

The YARA rules check if there is a combination of these keywords.

\subsubsection{Results}
On the test suite provided, our YARA rules detect the following:
\begin{itemize}
    \item \textbf{\textcolor{orange}{6 out of 7 malicious files}}: [\textit{mal1}, \textit{mal2}, \textit{mal3}, \textit{mal4}, \textit{mal5}, \textit{mal10}]
    \item \textbf{\textcolor{green}{0 out of 2 clean files}}.
\end{itemize}

Only the file \textit{mal6} is not detected by our rules.

%==================================================================%
\subsection{Phising campaign}
\begin{center}
    \textit{The YARA rules for this exercise is named: \textbf{"mail\_rules.yar"}}
\end{center}

\subsubsection{Description}
The overall condition for our YARA rules is to detect emails that do not contain the attacker's email address and a reply message from it.\\

It checks also if emails contain the subject line containing the word "Solution".

\subsubsection{Results}
On the test suite provided, our YARA rules detect the following:
\begin{itemize}
    \item \textbf{\textcolor{green}{7 out of 7 malicious emails}}: [\textit{phish1.eml}, \textit{phish1.eml}, \textit{phish2.eml}, \textit{phish3.eml}, \textit{phish4.eml}, \textit{phish5.eml}, \textit{phish6.eml}, \textit{phish7.eml}]
    \item \textbf{\textcolor{green}{0 out of 3 clean files}}.
\end{itemize}

%==================================================================%
%==================================================================%
%==================================================================%
\section{Reversing malware: Binary Analysis and exploitation}
For this second and last question, our goal is to exploit a binary file to get access to  another protected file.\\

\begin{center}
    \textit{We will work on the second option: \textbf{B - Binary Analysis and exploitation}}
\end{center}

\begin{center}
    \textit{For the explanation, the \textbf{address space randomization} is turned off but the trick even works enabled.}
\end{center}

\subsection{Analysis of the execution flow}
In the beginning, we have to decompile the \textbf{read\_secret} binary file with \textbf{GDB}.\\

The only thing we know about the program is it takes one argument in input: a string corresponding to the user who wants to access the \textit{secret.txt} file.\\

The workflow of the program is the following:
\begin{enumerate}
    \item The user put a string at the input of the program.
    \item A variable is assigned to the value \textit{400} (which is the code used to modify the \textit{secret.txt} file permission) [we will call it \textbf{perm}].
    \item The address of \textbf{perm} is printed.
    \item The program print "\textit{Welcome, }" followed by the input inserted before.
    \item It prints the first line of the \textit{secret.txt} file.
    \item At the end, the \textbf{chmod} command is run with the value of the variable \textbf{perm}.
\end{enumerate}

\subsection{The vulnerability}
\begin{lstlisting}[language=bash,caption={Solution to access to the \textbf{secret.txt} file}]
./read_secret $(python -c "print('#'*511+'%n')")
\end{lstlisting}
If we make a buffer overflow on the input, we can modify the variable \textbf{perm} which contains the next permission of the \textbf{secret.txt} file (which is by default \textit{400}).
So, if we make a Python script which generates the following input:
\begin{itemize}
    \item \textbf{A random character}: $'\#'\ (\times 511)$. It is used to go to the \textbf{perm} address variable.
    \item \textbf{The special command}: $'\% n'$. It writes the number of characters printed in STDOUT.\\
    It is used to override the \textbf{perm} address by the new address containing the value provided by $'\% n'$.\\
\end{itemize}
Thus, if we generate an input of 511 characters, the program will change the permission of the file from \textit{400} to \textit{777} (which corresponds to full access).
\begin{figure}[h]
    \centering
    \includegraphics[scale=0.5]{pictures/final_result.png}
    \caption{The final process to unlock the \textbf{secret.txt} file}
\end{figure}

\subsection{Fix for the vulnerability}
Multiple methods exist to fix this vulnerability:
\begin{itemize}
    \item Set the correct permission code directly into the \textbf{chmod} command.
    \item Use protected \textbf{printf} (\textit{printf("\%s", perm)})
\end{itemize}
